// C Source File
// Created 07/05/2002; 19:32:20

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files


// Main Function
void _main(void)
{

	#include "curs.h"
	#include "game.h"
	
	do
	{
		//cran de prsentation
		clrscr();
		FontSetSys(2);
		DrawStr(27, 10, "CARRE MAGIQUE", A_NORMAL);
		FontSetSys(0);
		DrawStr(61, 22, "version 1.0", A_NORMAL);
		DrawStr(48, 94, "Ecrit en C par Bob.", A_NORMAL);
		
		//clignotement de "Press Enter" et
		short key;
		float a,f;
		FontSetSys(1);
		do
		{
			GKeyFlush();  //vide la liste des touches presses (remet kbhit  0)
			DrawStr(22, 69, "Press Enter to play", A_XOR);
			DrawStr(28, 78, "Press ESC to quit", A_XOR);
			for(a=0; a<15; a++) f=sin(a);	//temporisation
			key=kbhit(); 									//teste si une touche a t presse
			if(key==KEY_ESC)   exit(1);   //si ESC, on quitte
			if(key==KEY_ENTER) break;     //si Enter, on continue (on sort de la boucle)
		}	
		while(TRUE);  //boucle pour le clignotement
		
		//affichage du tableau de jeu
		clrscr();
		int i;
		for(i=0; i<11; i++)
		{
			DrawLine(29+10*i, 2, 29+10*i, 82, A_NORMAL);
			DrawLine(29, 2+8*i, 129, 2+8*i, A_NORMAL);
		}
		
		GKeyFlush();  //pour viter de choisir tjrs la case en haut  gauche
									//car sans a, le prochain appel  ngetch() renvoit KEY_ENTER
		
		//Choix de la premire case grace  un curseur
		short int CursX=1, CursY=1;
		FontSetSys(0);
		DrawStr(32, 84, "Choisissez la premire case.", A_REPLACE);
		Sprite16(30, 3, 7, Curs, LCD_MEM, SPRT_XOR);  //affichage du curseur
		do
		{
			key=ngetchx();
			if(key==KEY_DOWN && CursY!=10)  MoveCurs(&CursX, 0, &CursY, 1);
			if(key==KEY_UP && CursY!=1)     MoveCurs(&CursX, 0, &CursY, -1);
			if(key==KEY_RIGHT && CursX!=10) MoveCurs(&CursX, 1, &CursY, 0);
			if(key==KEY_LEFT && CursX!=1)		MoveCurs(&CursX, -1, &CursY, 0);
		} 
		while(key!=KEY_ENTER);  //boucle de gestion du deplacement du curseur
		
		Sprite16(20+10*CursX, 8*CursY-5, 7, Curs, LCD_MEM, SPRT_XOR);  //on efface le curseur
		DrawStr(22+10*CursX, 8*CursY-4, "1", A_NORMAL); //on met un '1'  la place
		Sprite16(20+10*CursX, 8*CursY-5, 7, PourInv, LCD_MEM, SPRT_XOR); //et on inverse la couleur
																																		 //de la premire case
		
	  //le jeu
		short X=CursX, Y=CursY;
		short NbCourant=1;
		short CoupsJoues[100][2]={};	//pour revenir sur les coups jous
		char *txt="";  //buffer qui sert plus loin
		FontSetSys(0);
		DrawStr(8, 84, "Maintenant, essayez de remplir le carr.", A_REPLACE);
		Tableau[X-1][Y-1]=TRUE;  //la premire case est occupe
		CoupsJoues[0][1]=X; //sauve le premier coup
		CoupsJoues[0][2]=Y;
		do  //dbut de la boucle de jeu
		{
			key=ngetchx();  //attend une touche
			
			if(key==KEY_ESC)  //si ESC
			{
				DrawStr(8, 84, "Maintenant, essayez de remplir le carr.", A_XOR);
				DrawStr(23, 84, "Etes-vous sur de vouloir quitter?", A_REPLACE);
				DrawStr(42, 91, "Oui=Enter, Non=autre", A_REPLACE);
				if(ngetchx()==KEY_ENTER) exit(1);
	  		else 
	  		{
	  			DrawStr(42, 91, "Oui=Enter, Non=autre", A_XOR);
	  			DrawStr(8, 84, "Maintenant, essayez de remplir le carr.", A_REPLACE);
	  		}
			}
			
			if(key==KEY_BACKSPACE && NbCourant!=1) //si 'backspace'
			{
				Tableau[X-1][Y-1]=FALSE;  //la dernire case joue est libre
				CoupsJoues[NbCourant-1][1]=0;  //efface le dernier coup jou
				CoupsJoues[NbCourant-1][2]=0;
				Sprite16(20+10*X, 8*Y-5, 7, PourInv, LCD_MEM, SPRT_OR);  //efface le numro de la case
				Sprite16(20+10*X, 8*Y-5, 7, PourInv, LCD_MEM, SPRT_XOR);
				NbCourant--;  //on dcrmente le nombre courant
				X=CoupsJoues[NbCourant-1][1]; //on charge le dernier coup
				Y=CoupsJoues[NbCourant-1][2];
				Sprite16(20+10*X, 8*Y-5, 7, PourInv, LCD_MEM, SPRT_XOR); //on inverse la dernire case
			}
			
			if(CoupValable(X, Y, key)) // teste si le coup jou est valable (dans le tableau et non occup)
			{
				Sprite16(20+10*X, 8*Y-5, 7, PourInv, LCD_MEM, SPRT_XOR);  //on inverse la case courante
				switch(key)  //on se dplace suivant la touche presse
				{
					case '1': X=X-2; Y=Y+2;	break;
					case '2': 			 Y=Y+3;	break;
					case '3': X=X+2; Y=Y+2;	break;
					case '6': X=X+3; 				break;
					case '9': X=X+2; Y=Y-2;	break;
					case '8':        Y=Y-3; break;
					case '7': X=X-2; Y=Y-2; break;
					case '4': X=X-3; 				break;
					default:        				break;
				}
				Tableau[X-1][Y-1]=TRUE; //la case joue est maintenant occupe
				NbCourant++; //le nombre courant est incrment
				CoupsJoues[NbCourant-1][1]=X;  //on sauve le coup jou
				CoupsJoues[NbCourant-1][2]=Y;
				if(NbCourant!=100)
				{
					sprintf(txt, "%d", NbCourant); //crit le nombre dans la case
					DrawStr(24+10*X-DrawStrWidth(txt, 0)/2, 8*Y-4, txt, A_NORMAL);
					Sprite16(20+10*X, 8*Y-5, 7, PourInv, LCD_MEM, SPRT_XOR); //puis on inverse la case
				}
				else Sprite16(20+10*X, 8*Y-5, 7, Goal, LCD_MEM, SPRT_XOR); //on met drapeau de fin sur la
																																	 //case si on arrive  100
			}
		}
		while(TesteSiFini(X, Y)); //on va au coup suivant (s'il y en a un)
		
		DrawStr(8, 84, "Maintenant, essayez de remplir le carr.", A_XOR);
		DrawStr(50, 84, "fini!", A_REPLACE);                           ///// le problme est ici /////
		sprintf(txt, "Votre score est %d.", NbCourant);  //affichage du score
		DrawStr(floor((159-DrawStrWidth(txt,0))/2), 91, txt, A_XOR);
		
		ngetchx();	//attend une touche
	
	} while(TRUE); //boucle sans fin: on retourne au dbut du jeu!
}
